// ShareMEMDlg.cpp : implementation file
//

#include "stdafx.h"
#include "ShareMEM.h"
#include "ShareMEMDlg.h"
#include "ET199_32.h"

#pragma comment(lib, "ET199_32S.lib")

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

DWORD g_dwRet=0;
DWORD g_dwCount=0;
ET_CONTEXT *g_pContext=NULL;

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CShareMEMDlg dialog

CShareMEMDlg::CShareMEMDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CShareMEMDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CShareMEMDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CShareMEMDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CShareMEMDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CShareMEMDlg, CDialog)
	//{{AFX_MSG_MAP(CShareMEMDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON2, OnButton2)
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CShareMEMDlg message handlers

BOOL CShareMEMDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CShareMEMDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CShareMEMDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CShareMEMDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CShareMEMDlg::OnButton1() 
{
	// TODO: Add your control notification handler code here
	
	g_dwRet=0;
	g_dwCount=0;
	g_pContext=NULL;

	//öET199
	g_dwRet=ETEnum(NULL,&g_dwCount);

	if(g_dwRet != ET_E_INSUFFICIENT_BUFFER && g_dwRet)
		return;

	//ڴڴ洢CONTEXTṹ
	g_pContext = new ET_CONTEXT[g_dwCount];

	//0
	memset(g_pContext,0,sizeof(ET_CONTEXT)*g_dwCount);

	//ʹ÷Ļ½ö
	g_dwRet=ETEnum(g_pContext,&g_dwCount);
	if(g_dwRet)
	{
		delete [] g_pContext;
		return;
	}

	//ET199
	g_dwRet = ETOpen(&g_pContext[0]);
	if(g_dwRet)
	{
		delete [] g_pContext;
		return;
	}

	//ִпִļǰִ֤ļĿ¼ûPIN
	g_dwRet = ETVerifyPin(&g_pContext[0], ET_DEFAULT_USER_PIN, ET_USER_PIN_LEN, ET_USER_PIN);
	if(g_dwRet)
	{
		delete [] g_pContext;
		return;
	}

	//ִET199еĿִļ1001
	char pbOut[256] = {0};
	DWORD dwOutLen = 0;
	g_dwRet = ETExecute(&g_pContext[0],"1001", NULL, 0, pbOut, 256, &dwOutLen);
	if(g_dwRet)
	{
		delete [] g_pContext;
		return;
	}
	
	AfxMessageBox(pbOut);


	ETClose(&g_pContext[0]);
	delete [] g_pContext;	
}

void CShareMEMDlg::OnButton2() 
{
	// TODO: Add your control notification handler code here
	g_dwRet=0;
	g_dwCount=0;
	g_pContext=NULL;

	//öET199
	g_dwRet=ETEnum(NULL,&g_dwCount);

	if(g_dwRet != ET_E_INSUFFICIENT_BUFFER && g_dwRet)
		return;

	//ڴڴ洢CONTEXTṹ
	g_pContext = new ET_CONTEXT[g_dwCount];

	//0
	memset(g_pContext,0,sizeof(ET_CONTEXT)*g_dwCount);

	//ʹ÷Ļ½ö
	g_dwRet=ETEnum(g_pContext,&g_dwCount);
	if(g_dwRet)
	{
		delete [] g_pContext;
		return;
	}

	//ET199
	g_dwRet = ETOpen(&g_pContext[0]);
	if(g_dwRet)
	{
		delete [] g_pContext;
		return;
	}

	//ִпִļǰִ֤ļĿ¼ûPIN
	g_dwRet = ETVerifyPin(&g_pContext[0], ET_DEFAULT_USER_PIN, ET_USER_PIN_LEN, ET_USER_PIN);
	if(g_dwRet)
	{
		delete [] g_pContext;
		return;
	}

	//ִET199еĿִļ1002
	char pbOut[256] = {0};
	DWORD dwOutLen = 0;
	g_dwRet = ETExecute(&g_pContext[0],"1002", NULL, 0, pbOut, 256, &dwOutLen);
	if(g_dwRet)
	{
		delete [] g_pContext;
		return;
	}
	
	AfxMessageBox(pbOut);


	ETClose(&g_pContext[0]);
	delete [] g_pContext;	
	
}


